#ifndef catalogH
#define catalogH

#include "url.h"  // declaration of URL
#include "db.h"

#define MAX_QUERY_SIZE 1024

// after url is scanned, some info ( SIZE, MIME, IP ) might change
#define DB_HOST_UPDATE_QUERY "UPDATE hosts SET ip=%d WHERE id=%u"
#define DB_URL_UPDATE_QUERY "UPDATE links SET nsize=%u, mime=%u WHERE id=%u"

// once we found a new url - insert it (nsize,mime,uid,pass,path,hostid,parentid)
#define DB_URL_INSERT_QUERY "INSERT INTO links VALUES(%u,%u,\'%s\',\'%s\',\'%s\',%u,%u)"
// name,IP,port,prootocol
#define DB_HOST_INSERT_QUERY "INSERT INTO hosts VALUES(\'%s\',%d,%d,%d)"
// in order to insert link, we need to know hostid:
#define DB_HOST_SELECT_INSERTED_HOST "SELECT id FROM hosts WHERE host=\'%s\' AND port=%d AND prot=%d"

// if mime==HTML or unknown,this will insert added url in a queue to be scanned
#define DB_URL_SEARCHABLE_QUERY "INSERT INTO queue VALUES(%u,0)"

/// TODO: retrieve the depth from queue
#define DB_NEXT_URL_QUERY "\
        SET TRANSACTION ISOLATION LEVEL SERIALIZABLE\
        DECLARE @min_id int \
        BEGIN TRAN \
        SELECT @min_id = MIN(id) FROM queue(TABLOCKX) \
        DELETE FROM queue WHERE id = @min_id \
        COMMIT TRAN \
        SELECT l.id,l.nsize,l.mime,l.uid,l.pass,l.path,h.id,h.host,h.ip,h.port,h.prot \
        FROM links l,hosts h WHERE l.hostid=h.id AND l.id=@min_id "

class Catalog{ // use flat fixed size record files for now
   static DBase db;
   char query[MAX_QUERY_SIZE];
public:
   Catalog();
   ~Catalog();
   int get(URL * url);
   int add(URL* url, URL* parent); // check for infinite loops
   int update(URL * url);
    int AddEmail(char * email); // set the MIME content
};

#endif // catalogH
