#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "url.h"
#include "globals.h"

static bool debug_on;

// syntax is the same as when calling printf function
int dbg(char * format, ...){
static FILE * log;
va_list arglist;
char IniKeyVal[8];
        if(debug_on == OFF){
                return 0;
        } else if(debug_on == UNKNOWN){ // first time running
                GetPrivateProfileString("Spider","debug","=",IniKeyVal,sizeof IniKeyVal,INIFILE);
                if(!stricmp(IniKeyVal,"on")){
                        debug_on=ON;
                        dbg("Starting in debug mode!\n");
                } else {
                        debug_on=OFF;
                }
        }
        va_start(arglist,format);
#if LOGDEBUG
        if(!log){ log = fopen("debug.txt","w"); }
        if(!log){
                printf("Could not open log file...\n");
                return 0;
        }
        vfprintf(log,format,arglist);
        fflush(log);
#endif
#if SHOWDEBUG
        vprintf(format,arglist);
        fflush(stdout);
#endif
        va_end(arglist);
        return 0;
}


int err(char * format, ...){
static FILE * log;
va_list arglist;
        va_start(arglist,format);
        if(!log){ log = fopen("errors.txt","w"); }
        if(!log){ return 0; }
        vfprintf(log,format,arglist);
        fflush(log);
        if(debug_on==ON){
                dbg(format,arglist);
        } else {
                vprintf(format,arglist);
        }
        fflush(stdout);
        va_end(arglist);
        return 0;
}

char * PrintMime(int mime){
static char MimeTxt[32];
        switch(mime){
                case MIME_ERROR: strcpy(MimeTxt,"MIME_ERROR"); break;
                case MIME_UNKNOWN: strcpy(MimeTxt,"MIME_UNKNOWN"); break;
                case  MIME_PASSPROT: strcpy(MimeTxt,"MIME_PASSPROT"); break;
                case  MIME_OTHER: strcpy(MimeTxt,"MIME_OTHER"); break;
                case  MIME_IMAGE: strcpy(MimeTxt,"MIME_IMAGE"); break;
                case  MIME_MOVIE: strcpy(MimeTxt,"MIME_MOVIE"); break;
                case  MIME_HTML: strcpy(MimeTxt,"MIME_HTML"); break;
                case  MIME_TXT: strcpy(MimeTxt,"MIME_TXT"); break;
                case  MIME_ZIP: strcpy(MimeTxt,"MIME_ZIP"); break;
                case  MIME_EXE: strcpy(MimeTxt,"MIME_EXE"); break;
                case  MIME_MUSIC: strcpy(MimeTxt,"MIME_MUSIC"); break;
                case  MIME_REDIRECT: strcpy(MimeTxt,"MIME_REDIRECT"); break;
                case  MIME_SCRIPT: strcpy(MimeTxt,"MIME_SCRIPT"); break;
                case  MIME_EMBED: strcpy(MimeTxt,"MIME_EMBED"); break;
                default: strcpy(MimeTxt,"UNSUPPORTED MIME");
        }
        return MimeTxt;
}

int spacer(char c){
    switch(c){
        case '"' :
	case '\'':
        case ' ' :
        case '\t':
        case '\n':
        case '\r': return true;
	default: return false;
    }
}

// s2 has to be null terminated LOWER case with no blanks
// (c1%32== c2%32) for regular string comparison
char* issub(char * s1, char * s2){ // commpare s1 to s2 no case no space
char c1,c2;
        while(1){
                if(!(c2=*s2)) return s1; // end of "compare to" string
                if(!(c1=*s1)) return NULL; // end of buffer
                if( c1 <= ' '){ s1++; continue; } // skip blanks \n\r\t\s etc...
                if( (c1!=c2) && (c1!=(c2-32)) ) return NULL;
                s1++;
                s2++;
        }
}

