#ifndef netH
#define netH
#include "url.h"

#define WIN32  // unset WIN32 if compiling under unix
#ifdef WIN32 // just header files and function names are different
   #include <winsock2.h>
   #include <windows.h>
   #include <io.h>
#else // windows part
   #include <sys/types.h>
   #include <sys/socket.h>
   #include <netinet/in.h>
   #include <unistd.h>
   #include <netdb.h>
   #include <stdio.h>
   #include <string.h>
   #define closesocket close // I think it's  windows only
#endif // if UNIXLIKE

#define CONTENTLEN "content-length:" // issub() works on lower case only
#define CONTENTSTR "content-type:"
#define NETTIMEOUTMS 30000 // timeout after 30 seconds

class Net{
    unsigned char getmime(URL * url);
public:
    unsigned long bandwidth;
    Net(); // init net
    ~Net();
    int get(URL * url); // load remote html file into buffer
// download remote file into a local file, return filename or null
    char * download(URL * url);
    int DumpHead(char * buff);
    unsigned int read(SOCKET sock, char * buffer, unsigned int size);
};

#endif
 