// #include <stdio.h> // in case we printf info messages
#include "parser.h"   // includes url.h
#include "globals.h"

int Parser::parse(URL* parenturl){ // basic initialization of parser
   if(parenturl->mime == MIME_REDIRECT){ return 1;} // html is not there
   parent=parenturl; // init parent ulr instead of passing it to nexturl
   current=parent->buf; // main buffer which we will be parsing
   return 0; // blah bla bla blah :) why not return something when we can?
}

// 0 end of buffer, -1 corrupted tag, o.w. current="url start" and return mime
char Parser::findstart(){    // find start of a url
char * end;
   char mime = MIME_UNKNOWN; // default for mime type
   do{                       // buffer is null terminated
      if(*current=='<'){     // all tags start with "<"
         current++;
         end=issub(current,"imgsrc");
         if(end){ current=end; mime=MIME_IMAGE; break; }
         end=issub(current,"ahref" );
         if(end){ current=end; break; } // any mime
         end=issub(current,"frame" );
         if(end){ current=end; mime=MIME_HTML; break; }
         end=issub(current,"embedsrc");
         if(end){ current=end; mime=MIME_EMBED; break; }
/// handle <mime content-type: refresh> <body background="">
// should we search for these ? <applet> <javascript src="">
/// this is where we should try to predict mime by file extension
      }
      else if(issub(current,"http://"))
        break; // occurences of urls in text
      else if( !*current ){ return 0; } // buffer ended - no tags left
      current++;
   }while(*current);                   // just increment ( always true )
   if(mime != MIME_UNKNOWN ){
        dbg("[PARSER] Mime: %s\n",PrintMime(mime));
   }
   for(;*current; current++){           // skip blanks and "="
      if(tagbound(*current)) return -1; // tag closed before url was found
      if(*current!='=' && !spacer(*current)) return mime; // alpha char starts url
   }
   return 0; // ERROR - end of buffer
}

//0 - end of buffer, 1 - corrupted tag, end of a tag +1 otherwise
char * Parser::findend(){         // find the end of a url
char * i,c;                       // dereference a pointer only once
   for(i = current; (c=*i); i++){ // Null means tag was not closed properly
      if(c=='>'||spacer(c) ){ *i=0; return ++i; } // found the end of url
      if(c=='<') return (char*)1; // ERROR - start of next tag
   }
   return 0; // ERROR - premature buffer end
}

// returns 0 when reached buffer end, < 0 on error , > 0 found url
int Parser::nexturl(URL* urlout){    // parse url from *current into urlout
char * urlend; // don't change current till done with parsing url
   do{         // come back here while urlend is corrupted (look for a new tag)
      do{      // loop while link is corrupted or link is a script call
         urlout->mime = findstart(); // find a tag containing url
         if(!urlout->mime) return 0; // critical error - end of buffer
      } while(urlout->mime < 0);     // can not find tag containing url
      urlend = findend();            // find end of the tag
      if(!urlend) return 0;          // end of buffer reached - no more tags
      if(urlend!=(char*)1 ){ break; }
      current++;
   } while(1);        // while link is corrupted
   dbg("[PARSER] Found url %s\n", current);
   int err = urlout->scan(current,parent);   // url reads itself in
   current = urlend;                 // next tag is after this one
   return err;                       // if scan succeeded, we found url
}


