#include <condefs.h>
#pragma hdrstop
#pragma argsused
USEUNIT("url.cpp");
USEUNIT("parser.cpp");
USEUNIT("catalog.cpp");
USEUNIT("net.cpp");
USEUNIT("globals.cpp");
USEUNIT("db.cpp");
//----------------------- end of borland dependent stuff -------------------
#include <windows.h>
#include <stdio.h>
#include "catalog.h"
#include "parser.h"
#include "url.h"
#include "net.h"
#include "globals.h"

int main(int argc, char* argv[]){
URL url;
URL newurl;
Net net;
Catalog catalog;
Parser parser;
int err;
   char * buffer = new(char[BUFFSIZE]);
   if(!buffer) return 1;
   while(1){ // while buffer nukes a line
      dbg("################# DOWNLOADED: %uKb ################\n", net.bandwidth/1024);
      url.init(buffer,BUFFSIZE);
      if(catalog.get(&url)){ break; } // get url address from catalog
      net.get(&url); // get url content in buffer & get mime-type
      parser.parse(&url); // handle redirect here. url is "parent URL"
      catalog.update(&url); // this will update mime/ip if url->dirty is true
      if(url.mime != MIME_HTML && url.mime!=MIME_REDIRECT){ continue; }
      dbg("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
      do{
         err = parser.nexturl(&newurl);
         if(err>0){
            catalog.add(&newurl,&url); //parse next url out of buffer
            dbg("---------------------------------------------------------\n");
//            Sleep(3000);
         }
      } while(err);
   }
   return 0;
}

/*
BUGS:
 * make sure e-mail parsing works correctly
 * escape charatcters in http protocol ( in NET::write()? )
 * cannot select max(id) any more to insert into queue redo the whole add
   procedure to run in 1 batch or use MAX(id) only if TABLOCKX during TRAN
   Rewrite Catalog::add as one SQL batch that inserts into hosts,links & queue
 * what happens if connection to database breaks :) ?

TODO:
 * change bandwidth counter to accomodate > 4 gigs
 * add date to debug.txt name
 * delete constrains from queue table to speedup things?
 * use "select @@IDENTITY" after "insert into links"

 * add date and time to err() for logging

 * check if url insert faild because of duplicate key if not - err()
 * add direct execute to DBase without involving recordset

 * host blacklist - utility to find hosts that have too many links and
   remove them from queue
 * make sure Mime prediction based upon extension works
 * enable the redirection scan - should be done by parser::nexturl()
 * take care of the # after the URL ( truncate urls after it... )
 * base 64 encoding and authentification

 * add depth selection from queue by Catalog::get and code to check depth
 * implement maximum queue depth code

 * add date to e-mail table ( fill it in query not by default value)
 * add parent url id column to e-mail table
 * add date to links to store when url was added / searched / (Last-Modified:?)
 * add parent url id to links table
 * store <title> from web site or other meta information such as character set?

 * add time protocol or use "Date:" http directive and store host timezone
 * add priority to queue so that links with certain qualities can be favored
 * separate tables for ftp links?
 * add up/down flag for hosts?
 * add retry functionality when using cashed IP after looking up ip again
 * Reduce the # of times we try to enter host in DB by checking if path
   (New URL path) was absolute/local or same as parent url

 * audotmatically add DSN
 * add automatic table creation?
 * log 401 unathorized access errors... crack-crack :)  ?
REDESIGN:
 * Redesign buffer acess handling: add new class that will get tags/test/header
 * separate net::Connect() from net::Get()
 * move all local variables into classes to make code MT-Safe
 * make a switch() on 1st digit of HTTP status code?
 * RFC1945 suggests that we should always read as much as we can from socket
   when retrieving a site instead of what Content-lenght indicates but
   that slows down scan because we have to wait for remote to close connectin ?
LONG TERM MOD PLANS:
 * add SSL support?
 * Move project into visual studio
 * Word parser for search engine implementation
 * New protocol supports: FTP/Gopher/etc..
 * MySQL/MiniSQL support for unix
 * Add database support other than MSQL
 * Write make files for win/linux/solaris
 * webserver int the middle - spider gets and posts data to a web server instead
 of directly into a database.
DONE:
 * add bandwidth counter + log bandwidth
 * add debug level to ini file
 * separate log and debug files/procedures
 * turn on updates of existing URL to add type /date
 * store parent url in links table for each entry
 * Catalog::AddEmail(char *) - store emails in separate table.
 * read actual url size - this should speed up downloading
 * add url vs actual size read display
 * add MT safe dequeue batch or Stored procedure
 * parse userid password correctly so that e-mail is not added as userid/pass
 * use select() for non-blocking io
 */
