if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_links_hosts]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[links] DROP CONSTRAINT FK_links_hosts
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_queue_links]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[queue] DROP CONSTRAINT FK_queue_links
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[queue]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[queue]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[links]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[links]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[hosts]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[hosts]
GO

CREATE TABLE [dbo].[hosts] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[host] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ip] [int] NULL ,
	[port] [smallint] NULL ,
	[prot] [tinyint] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[links] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[nsize] [int] NULL ,
	[mime] [tinyint] NULL ,
	[uid] [varchar] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[pass] [varchar] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[path] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[hostid] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[queue] (
	[id] [int] NOT NULL ,
	[depth] [smallint] NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[hosts] WITH NOCHECK ADD 
	CONSTRAINT [PK_hosts] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_hosts_1] UNIQUE  NONCLUSTERED 
	(
		[host],
		[port],
		[prot]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[links] WITH NOCHECK ADD 
	CONSTRAINT [PK_links] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[links] ADD 
	CONSTRAINT [FK_links_hosts] FOREIGN KEY 
	(
		[hostid]
	) REFERENCES [dbo].[hosts] (
		[id]
	)
GO

ALTER TABLE [dbo].[queue] ADD 
	CONSTRAINT [FK_queue_links] FOREIGN KEY 
	(
		[id]
	) REFERENCES [dbo].[links] (
		[id]
	)
GO

