#ifndef urlH
#define urlH

#define MIME_ERROR     0  // error retreaving file
#define MIME_UNKNOWN   1  // never downloaded header
#define MIME_PASSPROT  2  // error retreaving file (password protected)
#define MIME_OTHER     3  // unknown content-type
#define MIME_IMAGE     4
#define MIME_MOVIE     5
#define MIME_HTML      6  // html only not TXT
#define MIME_TXT       7
#define MIME_ZIP       8  // all compressed files
#define MIME_EXE       9
#define MIME_MUSIC     10
#define MIME_REDIRECT  11  // server requested redirection (3xxx status code)
#define MIME_SCRIPT    12
#define MIME_EMBED     13  // <embed src="" >

#define PROT_UNKNOWN 0
#define PROT_OTHER   1
#define PROT_HTTP    2
#define PROT_FTP     3
#define PROT_EMAIL   4
#define PROT_FILE    5
#define PROT_NEWS    6
#define PROT_TELNET  7

#define PORT_DEFAULT 0
#define HEADSIZE 512
#define HOSTSIZE 112
#define PATHSIZE 256
#define USERPASSIZE 32


// store time of url retrieval
class URL{ // userid and password (authentification) is not implemented
public:
   char * buf;
   char dirty; // dirty bit - size/mime/ip changed
   int size; // size of the file ( from content-length:)
   unsigned int ID; // used in memory only - corresponds to record # in file
   char mime;
   unsigned char protocol; // http:// ftp:// file://
   unsigned short port;
   int ip;
   char userid[USERPASSIZE];
   char password[USERPASSIZE];
   char host[HOSTSIZE];
   char path[PATHSIZE];
    unsigned int hostID;

   int setuid(char * uid);
   int setpass(char * pass);
   int sethost(char * newhost);
   int setpath(char * newpath);
   int scan(char * url, URL * parent);  // scan url from string into structure
   int init(char * buffer, int buffsize);
};

#endif
